diff -uprN ./audio_filter/pre_emphisize.c /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/pre_emphisize.c
--- ./audio_filter/pre_emphisize.c	2009-08-12 11:01:25.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/pre_emphisize.c	1970-01-01 08:00:00.000000000 +0800
@@ -1,139 +0,0 @@
-/*****************************************************************************
- * emphisize.c: to lift the high-frequency filter
- *****************************************************************************
- * Copyright (C) 2001, 2006 the VideoLAN team
- * $Id$
- *
- * Authors: richard wang <wangxiang68@gmail.com>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
- *****************************************************************************/
-
-/*
- * TODO:
- *
- * 
- * Because in the speech signal processing theory, the frequency of 
- * 6kz-8kz should be emphsized y(n) = x(n)- a*x(n-1) equal to H(Z) = 1- a/Z */
-
-
-/*****************************************************************************
- * Preamble
- *****************************************************************************/
-
-#ifdef HAVE_CONFIG_H
-# include "config.h"
-#endif
-
-#include <errno.h>                                                 /* ENOMEM */
-#include <ctype.h>
-#include <signal.h>
-
-#include <math.h>
-
-
-#include <vlc_common.h>
-#include <vlc_plugin.h>
-
-#include <vlc_aout.h>
-
-/*****************************************************************************
- * Local prototypes
- *****************************************************************************/
-
-static int  Open     ( vlc_object_t * );
-static void DoWork   ( aout_instance_t * , aout_filter_t *,
-                aout_buffer_t * , aout_buffer_t *);
-
-/*****************************************************************************
- * Module descriptor
- *****************************************************************************/
-#define BUFF_TEXT N_("Number of audio buffers" )
-#define BUFF_LONGTEXT N_("the frequency of  6kz-8kz should be emphsized y(n) = 1-0.97*y(n-1) ")
-
-vlc_module_begin();
-    set_description( N_("Raise the voice of speaker") );
-    set_shortname( N_("Raise the voice of speaker") );
-    set_capability( "audio filter", 0 );
-    set_callbacks( Open, Close );
-vlc_module_end();
-
-/*****************************************************************************
- * Open: initialize and create stuff
- *****************************************************************************/
-static int Open( vlc_object_t *p_this )
-{
-    aout_filter_t *p_filter = (aout_filter_t*)p_this;
-    int i_channels;
-
-    if( p_filter->input.i_format != VLC_FOURCC('f','l','3','2' ) ||
-        p_filter->output.i_format != VLC_FOURCC('f','l','3','2') )
-    {
-        b_fit = false;
-        p_filter->input.i_format = VLC_FOURCC('f','l','3','2');
-        p_filter->output.i_format = VLC_FOURCC('f','l','3','2');
-        msg_Warn( p_filter, "bad input or output format" );
-    }
-
-    if ( !AOUT_FMTS_SIMILAR( &p_filter->input, &p_filter->output ) )
-    {
-        b_fit = false;
-        memcpy( &p_filter->output, &p_filter->input,
-                sizeof(audio_sample_format_t) );
-        msg_Warn( p_filter, "input and output formats are not similar" );
-    }
-
-    p_filter->pf_do_work = DoWork;
-    p_filter->b_in_place = true;
-
-    i_channels = aout_FormatNbChannels( &p_filter->input );
-
-    return VLC_SUCCESS;
-}
-
-/*****************************************************************************
- * DoWork : normalizes and sends a buffer
- *****************************************************************************/
- static void DoWork( aout_instance_t *p_aout, aout_filter_t *p_filter,
-                     aout_buffer_t *p_in_buf, aout_buffer_t *p_out_buf )
-{
-    int i, i_chan;
-
-    int i_samples = p_in_buf->i_nb_samples;
-    int i_channels = aout_FormatNbChannels( &p_filter->input );
-    float *p_out = (float*)p_out_buf->p_buffer;
-    float *p_in =  (float*)p_in_buf->p_buffer;
-
-    struct aout_filter_sys_t *p_sys = p_filter->p_sys;
-
-    p_out_buf->i_nb_samples = p_in_buf->i_nb_samples;
-    p_out_buf->i_nb_bytes = p_in_buf->i_nb_bytes;
-
-/*Apply Pre-emphasize*/	
-	for (i = i_samples-1; i > 0; i-- )
-	{
-		for (i_chan = 0; i_chan < i_channels; i++)
-		{
-			p_out[i+i_chan] = p_in[i+i_chan] - p_in[i-1+i_chan]*0.97;
-		}
-	}
-
-	for (i_chan = 0; i_chan < i_channels; i++)
-	{
-		p_out[i_chan] = 0.03*p_in[i_chan];
-	}
-	
-    return;
-}
\ No newline at end of file
diff -uprN ./audio_filter/reverbation/all-pass.cpp /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/all-pass.cpp
--- ./audio_filter/reverbation/all-pass.cpp	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/all-pass.cpp	1970-01-01 08:00:00.000000000 +0800
@@ -1,75 +0,0 @@
-/*********************************************************
-
-Allpass.cpp - An allpass filter designed to build reverberators
-	Google Summer Code 2009
-	Author: Xiang Wang
-*********************************************************/
-
-#include "all-pass.h"
-// ***************  Comb(float, float)  ***************
-
-Allpass :: Allpass(float delayTime, float feedbackGain)
-{
-  gain = feedbackGain;
-  delay = delayTime;  //delay time is in milliseconds
-
-}
-
-void Allpass :: SetParam(float delayTime, float feedbackGain,int numsamples)
-{
-	gain = feedbackGain;
-	delay = delayTime;  //delaytime in milliseconds
-	frameLength = numsamples;
-}
-
-void Allpass :: SetSignal(float * inputs, float * outputs)
-{
-	inputSignal = inputs;
-	outputSignal = outputs;
-}
-
-// ***************  Initialize(void)  ********************
-
-void Allpass :: Initialize (void)
-{
-  int bufferLength = int(delay*samplingRate/1000);
-  bufferStart = new float[bufferLength];
-  bufferEnd = bufferStart + bufferLength;
-
-  //zero out the buffer (create silence)
-  for(i=0; i<bufferLength; i++)
-    bufferStart[i] = 0.0;
-
-  //set read pointer to start of buffer
-  readPtr = bufferStart;
-
-  return;
-}
-
-
-// **************** Process(void)  ********************
-
-void Allpass :: Process (void)
-{
-  float temp;
-
-  for(i=0; i<frameLength; i++) {  //for each sample...
-    temp = *readPtr;
-    *readPtr = gain * temp + inputSignal[i];
-    outputSignal[i] = temp - gain * *readPtr;
-
-    if(++readPtr >= bufferEnd)  //if reach end of buffer, wrap
-      readPtr = bufferStart;
-  }
-
-}
-
-
-// *****************  Cleanup(void)  ******************
-
-void Allpass :: Cleanup (void)
-{
-  delete [] bufferStart;
-
-  return;
-}
diff -uprN ./audio_filter/reverbation/all-pass.h /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/all-pass.h
--- ./audio_filter/reverbation/all-pass.h	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/all-pass.h	1970-01-01 08:00:00.000000000 +0800
@@ -1,34 +0,0 @@
-/*********************************************************
-
-Allpass.h - An allpass filter designed to build reverberators
-	Google Summer Code 2009
-	Author: Xiang Wang
-*********************************************************/
-
-
-#ifndef ALLPASS_H
-#define ALLPASS_H
-
-#include "comm.h"
-
-class Allpass{
-public:
-  Allpass(float delay, float gain);  //delay in milliseconds
-  void Initialize(void);
-  void Process(void);
-  void Cleanup(void);
-  void SetParam(float delayTime, float feedbackGain,int numsamples);
-  void SetSignal(float * inputs, float * outputs);
-
-  ~Allpass(){;}
-
-private:
-  float delay, gain;
-  float * bufferStart, * bufferEnd, * readPtr;
-  float * inputSignal, * outputSignal;
-  int i, frameLength;
-  Allpass(Allpass&){};
-};
-
-
-#endif
diff -uprN ./audio_filter/reverbation/comb.cpp /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comb.cpp
--- ./audio_filter/reverbation/comb.cpp	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comb.cpp	1970-01-01 08:00:00.000000000 +0800
@@ -1,76 +0,0 @@
-/*********************************************************
-
-Comb.cpp - A comb filter for building reverberators
-	Google Summer Code 2009
-	Author : Xiang Wang
-*********************************************************/
-
-
-#include "Comb.h"
-
-
-// ***************  Comb(float, float)  ***************
-
-Comb :: Comb(float delayTime, float feedbackGain)
-{
-
-  gain = feedbackGain;
-  delay = delayTime;  //delaytime in milliseconds
-
-}
-
-void Comb :: SetParam(float delayTime, float feedbackGain,int numsamples)
-{
-	gain = feedbackGain;
-	delay = delayTime;  //delaytime in milliseconds
-	frameLength = numsamples;
-}
-
-void Comb :: SetSignal(float * inputs, float * outputs)
-{
-	inputSignal = inputs;
-	outputSignal = outputs;
-}
-// ***************  Initialize(void)  ********************
-
-void Comb :: Initialize (void)
-{
-  int bufferLength = int(delay*samplingRate/1000);
-  bufferStart = new float[bufferLength];
-  bufferEnd = bufferStart + bufferLength;
-
-  //zero out the buffer (silence)
-  for(i=0; i<bufferLength; i++)
-    bufferStart[i] = 0.0;
-
-  //set read pointer to start of buffer
-  readPtr = bufferStart;
-
-  //assign pointers for the only input and output
-  return;
-}
-
-
-// **************** Process(void)  ********************
-
-void Comb :: Process (void)
-{
-  for(i=0; i<frameLength; i++) {  //for each sample...
-    outputSignal[i] = (short) *readPtr;  //read the value
-    //write the scaled value + the new input sample
-    *readPtr = (*readPtr)*gain + inputSignal[i];
-
-    if(++readPtr >= bufferEnd) //if reach end of buffer, wrap
-      readPtr = bufferStart;
-  }
-}
-
-
-// *****************  Cleanup(void)  ******************
-
-void Comb :: Cleanup (void)
-{
-  delete [] bufferStart;
-
-  return;
-}
diff -uprN ./audio_filter/reverbation/comb.h /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comb.h
--- ./audio_filter/reverbation/comb.h	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comb.h	1970-01-01 08:00:00.000000000 +0800
@@ -1,33 +0,0 @@
-/*********************************************************
-
-Comb.cpp - A comb filter for building reverberators
-	Goolge Summer Code 2009
-	Author: xiang wang
-*********************************************************/
-
-
-#ifndef COMB_H
-#define COMB_H
-
-#include "comm.h"
-
-class Comb {
-public:
-	Comb(float delay, float gain);  //delay is in milliseconds
-	void Initialize(void);
-	void Process(void);
-	void Cleanup(void);
-	void SetParam(float delayTime, float feedbackGain,int numsamples);
-	void SetSignal(float * inputs, float * outputs);
-
-	~Comb(){;}
-
-private:
-	float delay, gain;
-	float * bufferStart, * bufferEnd, * readPtr;
-	float * inputSignal, * outputSignal;
-	int i, frameLength;
-	Comb(Comb&){};
-};
-
-#endif
diff -uprN ./audio_filter/reverbation/comm.h /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comm.h
--- ./audio_filter/reverbation/comm.h	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/comm.h	1970-01-01 08:00:00.000000000 +0800
@@ -1,16 +0,0 @@
-#ifndef _COMM_H_
-#define _COMM_H_
-
-
-#include <stdlib.h>
-#include <stdio.h>
-#include <math.h>
-#include <string.h>
-
-
-
-#define samplingRate 441000
-#define f_delay 30
-#define f_feedback 0.6
-
-#endif
\ No newline at end of file
diff -uprN ./audio_filter/reverbation/Makefile.am /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/Makefile.am
--- ./audio_filter/reverbation/Makefile.am	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/Makefile.am	1970-01-01 08:00:00.000000000 +0800
@@ -1,22 +0,0 @@
-# modules/audio_filter/spatializer/Makefile.am automatically generated from modules/audio_filter/spatializer/Modules.am by modules/genmf
-# DO NOT EDIT THIS FILE DIRECTLY! See Modules.am instead.
-
-basedir = audio_filter
-dir = audio_filter/reverbation
-mods = reverbation
-libvlc_LTLIBRARIES =  $(LTLIBspatializer)
-EXTRA_LTLIBRARIES =  libspatializer_plugin.la
-
-include $(top_srcdir)/modules/common.am
-
-# The spatializer plugin
-libspatializer_plugin_la_SOURCES = $(SOURCES_spatializer)
-nodist_libspatializer_plugin_la_SOURCES = $(nodist_SOURCES_spatializer)
-# Force per-target objects:
-libspatializer_plugin_la_CFLAGS = $(AM_CFLAGS)
-libspatializer_plugin_la_CXXFLAGS = $(AM_CXXFLAGS)
-libspatializer_plugin_la_OBJCFLAGS = $(AM_OBJCFLAGS)
-# Set LIBADD and DEPENDENCIES manually:
-libspatializer_plugin_la_LIBADD = $(AM_LIBADD)
-libspatializer_plugin_la_DEPENDENCIES =
-
diff -uprN ./audio_filter/reverbation/Modules.am /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/Modules.am
--- ./audio_filter/reverbation/Modules.am	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/Modules.am	1970-01-01 08:00:00.000000000 +0800
@@ -1,4 +0,0 @@
-SOURCES_spatializer = reverbation.cpp \
-    allpass.cpp allpass.h comb.cpp comb.h
-
-
diff -uprN ./audio_filter/reverbation/reverbation.c /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/reverbation.c
--- ./audio_filter/reverbation/reverbation.c	2009-08-12 11:00:55.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/reverbation/reverbation.c	1970-01-01 08:00:00.000000000 +0800
@@ -1,150 +0,0 @@
-/*****************************************************************************
- * emphisize.c: to lift the high-frequency filter
- *****************************************************************************
- * Copyright (C) 2001, 2006 the VideoLAN team
- * $Id$
- *	Google Summer of Code 2009
- * Authors: richard wang <wangxiang68@gmail.com>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
- *****************************************************************************/
-
-/*
- * TODO:
- *
- * 
- * The Reverbation.c is to make room reverbations */
-
-
-/*****************************************************************************
- * Preamble
- *****************************************************************************/
-
-#ifdef HAVE_CONFIG_H
-# include "config.h"
-#endif
-
-#include <errno.h>                                                 /* ENOMEM */
-#include <ctype.h>
-#include <signal.h>
-
-#include <math.h>
-
-
-#include <vlc_common.h>
-#include <vlc_plugin.h>
-
-#include <vlc_aout.h>
-
-
-#include "comb.h"
-#include "all-pass.h"
-
-/*****************************************************************************
- * Local prototypes
- *****************************************************************************/
-
-static int  Open     ( vlc_object_t * );
-static void DoWork   ( aout_instance_t * , aout_filter_t *,
-                aout_buffer_t * , aout_buffer_t *);
-
-/*****************************************************************************
- * Module descriptor
- *****************************************************************************/
-#define BUFF_TEXT N_("make room reverbations" )
-#define BUFF_LONGTEXT N_("make room reverbations ")
-
-vlc_module_begin();
-    set_description( N_("make room reverbations") );
-    set_shortname( N_("make room reverbations") );
-    set_capability( "audio filter", 0 );
-    set_callbacks( Open, Close );
-vlc_module_end();
-
-/*****************************************************************************
- * Open: initialize and create stuff
- *****************************************************************************/
-static int Open( vlc_object_t *p_this )
-{
-    aout_filter_t *p_filter = (aout_filter_t*)p_this;
-    int i_channels;
-
-    if( p_filter->input.i_format != VLC_FOURCC('f','l','3','2' ) ||
-        p_filter->output.i_format != VLC_FOURCC('f','l','3','2') )
-    {
-        b_fit = false;
-        p_filter->input.i_format = VLC_FOURCC('f','l','3','2');
-        p_filter->output.i_format = VLC_FOURCC('f','l','3','2');
-        msg_Warn( p_filter, "bad input or output format" );
-    }
-
-    if ( !AOUT_FMTS_SIMILAR( &p_filter->input, &p_filter->output ) )
-    {
-        b_fit = false;
-        memcpy( &p_filter->output, &p_filter->input,
-                sizeof(audio_sample_format_t) );
-        msg_Warn( p_filter, "input and output formats are not similar" );
-    }
-
-    p_filter->pf_do_work = DoWork;
-    p_filter->b_in_place = true;
-
-    i_channels = aout_FormatNbChannels( &p_filter->input );
-
-    return VLC_SUCCESS;
-}
-
-/*****************************************************************************
- * DoWork : normalizes and sends a buffer
- *****************************************************************************/
- static void DoWork( aout_instance_t *p_aout, aout_filter_t *p_filter,
-                     aout_buffer_t *p_in_buf, aout_buffer_t *p_out_buf )
-{
-    int i, i_chan;
-
-    int i_samples = p_in_buf->i_nb_samples;
-    int i_channels = aout_FormatNbChannels( &p_filter->input );
-    float *p_out = (float*)p_out_buf->p_buffer;
-    float *p_in =  (float*)p_in_buf->p_buffer;
-/************************************************************************/
-/*                          Only Suppor One Channel Now                 */
-/************************************************************************/
-	if (i_channels>1)
-	{
-		return;
-	}
-	
-    p_out_buf->i_nb_samples = p_in_buf->i_nb_samples;
-    p_out_buf->i_nb_bytes = p_in_buf->i_nb_bytes;
-
-	Comb comb;
-	Allpass allpass;
-
-/******Comb filtering***********/
-	Comb combs(f_delay,f_feedback);
-	combs.SetParam(f_delay,f_feedback,i_samples);
-	combs.SetSignal(p_in,p_out);
-	combs.Initialize();
-	combs.Process();
-
-/******All-pass filtering***********/
-	Allpass allpass(f_delay,f_feedback);
-	allpass.SetParam(f_delay,f_feedback,i_samples);
-	allpass.SetSignal(p_out,p_out);
-	allpass.Initialize();
-	allpass.Process();
-	
-    return;
-}
diff -uprN ./audio_filter/simple_echo.c /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/simple_echo.c
--- ./audio_filter/simple_echo.c	2009-08-12 11:01:11.000000000 +0800
+++ /home/xwang/GSOC2009/VideoLan/vlc-ori/modules/audio_filter/simple_echo.c	1970-01-01 08:00:00.000000000 +0800
@@ -1,144 +0,0 @@
-/*****************************************************************************
- * emphisize.c: to lift the high-frequency filter
- *****************************************************************************
- * Copyright (C) 2001, 2009 the VideoLAN team
- * $Id$
- *
- * Authors: richard wang <wangxiang68@gmail.com>
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
- *****************************************************************************/
-
-/*
- * TODO:
- *
- * 
- * The basic idea of echo is to shift the wave by some frames */
-
-
-/*****************************************************************************
- * Preamble
- *****************************************************************************/
-
-#ifdef HAVE_CONFIG_H
-# include "config.h"
-#endif
-
-#include <errno.h>                                                 /* ENOMEM */
-#include <ctype.h>
-#include <signal.h>
-
-#include <math.h>
-
-
-#include <vlc_common.h>
-#include <vlc_plugin.h>
-
-#include <vlc_aout.h>
-
-#define Shift_Frame  1000
-
-/*****************************************************************************
- * Local prototypes
- *****************************************************************************/
-
-static int  Open     ( vlc_object_t * );
-static void DoWork   ( aout_instance_t * , aout_filter_t *,
-                aout_buffer_t * , aout_buffer_t *);
-
-/*****************************************************************************
- * Module descriptor
- *****************************************************************************/
-#define BUFF_TEXT N_("Number of audio buffers" )
-#define BUFF_LONGTEXT N_("Make music some echo effects ")
-
-vlc_module_begin();
-    set_description( N_("Make music some echo effects") );
-    set_shortname( N_("Make music some echo effects") );
-    set_capability( "audio filter", 0 );
-    set_callbacks( Open, Close );
-vlc_module_end();
-
-/*****************************************************************************
- * Open: initialize and create stuff
- *****************************************************************************/
-static int Open( vlc_object_t *p_this )
-{
-    aout_filter_t *p_filter = (aout_filter_t*)p_this;
-    int i_channels;
-
-    if( p_filter->input.i_format != VLC_FOURCC('f','l','3','2' ) ||
-        p_filter->output.i_format != VLC_FOURCC('f','l','3','2') )
-    {
-        b_fit = false;
-        p_filter->input.i_format = VLC_FOURCC('f','l','3','2');
-        p_filter->output.i_format = VLC_FOURCC('f','l','3','2');
-        msg_Warn( p_filter, "bad input or output format" );
-    }
-
-    if ( !AOUT_FMTS_SIMILAR( &p_filter->input, &p_filter->output ) )
-    {
-        b_fit = false;
-        memcpy( &p_filter->output, &p_filter->input,
-                sizeof(audio_sample_format_t) );
-        msg_Warn( p_filter, "input and output formats are not similar" );
-    }
-
-    p_filter->pf_do_work = DoWork;
-    p_filter->b_in_place = true;
-
-    i_channels = aout_FormatNbChannels( &p_filter->input );
-
-    return VLC_SUCCESS;
-}
-
-/*****************************************************************************
- * DoWork : normalizes and sends a buffer
- *****************************************************************************/
- static void DoWork( aout_instance_t *p_aout, aout_filter_t *p_filter,
-                     aout_buffer_t *p_in_buf, aout_buffer_t *p_out_buf )
-{
-    int i, i_chan;
-
-    int i_samples = p_in_buf->i_nb_samples;
-    int i_channels = aout_FormatNbChannels( &p_filter->input );
-    float *p_out = (float*)p_out_buf->p_buffer;
-    float *p_in =  (float*)p_in_buf->p_buffer;
-
-    p_out_buf->i_nb_samples = p_in_buf->i_nb_samples;
-    p_out_buf->i_nb_bytes = p_in_buf->i_nb_bytes;
-
-	int i_shift_samples;
-/*Apply Pre-emphasize*/	
-	for (i = 0; i < i_samples; i++ )
-	{
-		for (i_chan = 0; i_chan < i_channels; i_chan++)
-		{
-			i_shift_samples = i_chan+Shift_Frame
-			if (i_shift_samples<i_samples)
-			{
-				p_out[i_chan] = p_in[i_chan] + p_in[i_shift_samples];
-			}
-			else
-			{
-				p_out[i_chan] = p_in[i_chan];
-			}
-		}
-		p_in += i_channels;
-		p_out += i_channels;
-	}
-	
-    return;
-}